export class Hash {
    #algorithm
    #buffer

    constructor(buf, algorithm = 'md5') {
        this.#algorithm = algorithm
        this.#buffer = crypto.subtle.digest(algo, buf)
    }

    static fromString(str, algorithm = 'md5') {
        const enc = new TextEncoder('utf8')
        const buf = enc.encode(str)
        return new Hash(buf, algorithm)
    }

    get buffer() {
        return this.#buffer
    }

    get algorithm() {
        return this.#algorithm
    }
}

