const topics = new Map()

export const publish = (topic, data) => {
    topics.has(topic) && topics.get(topic).forEach(sub => {
        sub(data !== undefined ? data : {})
    })
}

export const subscribe = (topic, subscription) => {
    if (!topics.has(topic)) {
        topics.set(topic, new Set())
    }

    topics.get(topic).add(subscription)

    return {
        remove: () => {
            topics.get(topic).delete(subscription)
        }
    }
}

